#include "stdio.h"
#include "stdlib.h"
#include "mkl.h"
#define M 12
#define N 8
#define K 4
int main()
{
  int m = M, n = N, k= K, incx = 1, incy = 1, incz = 1, incv = 1, i, j;
  double alpha = 1.0, beta = 0.0, da = 2.0;
  double x[M], y[N], z[N], v[K], c;
  double A[M*K], B[K*N], C[M*N], D[K*N];
  for( i = 0; i < n; i++ ){
    x[i] = (double)(i + 1);
    y[i] = (double)(n - i);
  }
  for( i = n; i < m; i++ ){
    x[i] = (double)i;
  }
  printf( "VECTOR x:\n" );
  for( i = 0; i < m; i++ ){
    printf( "%12.6f ", x[i] );
  }
  printf( "\n" );
  printf( "VECTOR y:\n" );
  for( i = 0; i < n; i++ ){
    printf( "%12.6f ", y[i] );
  }
  printf( "\n" );
  for( i = 0; i < m*k; i++ ){
    A[i] = (double)(i + 1);
  }
  printf( "MATRIX A:\n" );
  for( i = 0; i < m; i++ ){
    for( j = 0; j < k; j++ ){
      printf( "%12.6f ", A[k*i+j] );
    }
    printf( "\n" );
  }
  for( i = 0; i < k*n; i++ ){
    B[i] = (double)(k*n - i);
  }
  printf( "MATRIX B:\n" );
  for( i = 0; i < k; i++ ){
    for( j = 0; j < n; j++ ){
      printf( "%12.6f ", B[n*i+j] );
    }
    printf( "\n" );
  }
  cblas_dcopy( n, y, incy, z, incz );
  printf( "## dcopy ## VECTOR z:\n" );
  for( i = 0; i < n; i++ ){
    printf( "%12.6f ", z[i] );
  }
  printf( "\n" );
  cblas_dscal( n, da, z, incz);
  printf( "## dscal ## VECTOR z:\n" );
  for( i = 0; i < n; i++ ){
    printf( "%12.6f ", z[i] );
  }
  printf( "\n" );
  c = cblas_dnrm2( n, z, incz);
  printf( "sqrt( z''*z ) = %12.6f\n", c );
  c = cblas_ddot( n, z, incz, y, incy );
  printf( "z dot y = %12.6f\n", c );
  cblas_dgemv( CblasRowMajor, CblasNoTrans, k, n, alpha, B, n, y, incy, beta, v, incv );
  printf( "## dgemv ## VECTOR v:\n" );
  for( i = 0; i < k; i++ ){
    printf( "%12.6f ", v[i] );
  }
  printf( "\n" );
  cblas_dger( CblasRowMajor, k, n, alpha, v, incv, y, incy, D, n );
  printf( "## dger ## MATRIX D:\n" );
  for( i = 0; i < k; i++ ){
    for( j = 0; j < n; j++ ){
      printf( "%12.6f ", D[n*i+j] );
    }
    printf( "\n" );
  }
  cblas_dgemm( CblasRowMajor, CblasNoTrans, CblasNoTrans, m, n, k, alpha, A, k, B, n, beta, C, n );
  printf( "## dgemm ## MATRIX C:\n" );
  for( i = 0; i < n; i++ ){
    for( j = 0; j < m; j++ ){
      printf( "%12.6f ", C[m*i+j] );
    }
    printf( "\n" );
  }
  return 0;
}
