program es_lapack
implicit none

integer :: i, j, info
character(len=*) , parameter :: FMT='(12E12.5)'
! LAPACK routine
external :: dgesv
! Matrix
integer :: N, LDA, LDB
parameter ( N=12 )
real*8 , allocatable :: A(:,:), B(:)
integer, allocatable :: ipiv(:)
LDA = N
LDB = N
! Memory allocation
allocate( A( N, N ) )
allocate( B( N ) )
allocate( ipiv( N ) )


! Vector and matrix elements generation
do j=1,N
  do i=1,N
    if(i.eq.j) then
      A(i,j) = dble(10000)
   else
      A(i,j) = (dble(i)+dble(j)/dble(2.0))
   endif
  enddo
enddo
do i=1,N
  B(i) = dble(207-i)
enddo

write(*,*) 'BEFORE...'
write(*,*) 'MATRIX A:'
do i=1,N
   write(*,FMT) ( A(i,j), j=1,N )
enddo
write(*,*) 'VECTOR B:'
write(*,FMT) ( B(i), i=1,N )

call dgesv( N, 1, A, LDA, ipiv, B, LDB, info )
if(info.eq.0) write(*,*) 'OK'

write(*,*) 'AFTER...'
write(*,*) 'MATRIX A:'
do i=1,N
   write(*,'(100E12.5)') ( A(i,j), j=1,N )
enddo
write(*,*) 'VECTOR B:'
write(*,FMT) ( B(i), i=1,N )
write(*,*) 'VECTOR IPIV:'
write(*,FMT) ( ipiv(i), i=1,N )

end program es_lapack

